/**
  * MyTriangle.java
  * rappresenta un triangolo. Realizza l'interfaccia Polygon.java.
  * @author A. Luchetta
  * @version 18-Nov-2006
  */
public class MyTriangle extends MyPolygon
{
   /**
      costruttore
      @param p array contenente i vertici del triangolo
   */
   public MyTriangle(MyPoint2D[] p)
   {
      super(p);
   }

   /**
      costruttore
      @param p1 primo vertice del triangolo
      @param p2 secondo vertice del triangolo
      @param p3 terzo vertice del triangolo
   */
   public MyTriangle(MyPoint2D p1, MyPoint2D p2, MyPoint2D p3)
   {
      this(new MyPoint2D[] {p1, p2, p3});
   }

   /**
      calcola l'area del triangolo
      @return l'area del triangolo
   */
   public double area()
   {
      double[] lines = getLines();

      double p = perimeter() / 2;
      return Math.sqrt(p * (p - lines[0]) * (p - lines[1]) * (p - lines[2]));
   }
}





