/**
  * PolygonTester.java
  * Classe di prova
  * @author A. luchetta
  * @version 18-Nov-2006
  */

import java.util.Scanner;
import java.util.Locale;
import java.util.NoSuchElementException;

public class PolygonTester
{
   public static void main(String[] args)
   {
      final char COMMENT_CHARACTER = '*';
      final int POINTS_MAX_NUMBER = 4;

      // apertura in lettura del file
      Scanner in = new Scanner(System.in);

      // lettura file e memorizzazione ordinata dei poligoni
      System.out.println("Lettura dati:");
      SortedContainer archivio = new SortedContainer();

      int numRiga = 0;
      while (in.hasNextLine())
      {
         numRiga++;
         String line = in.nextLine();
         System.out.println("riga " + numRiga + " " + line);
         
         if (line.charAt(0) != COMMENT_CHARACTER)
         {
   	        Scanner tok = new Scanner(line);
   	        tok.useDelimiter("[ ()]+");
   	        tok.useLocale(Locale.US);
   	        
   	        MyPoint2D[] p = new MyPoint2D[POINTS_MAX_NUMBER];

            int i = 0;
            
            try
            {
               while (tok.hasNextDouble())
                  p[i++] = new MyPoint2D(tok.nextDouble(), tok.nextDouble());
               
               MyPoint2D[] q = new MyPoint2D[i];
               for (int j = 0; j < i; j++)
                  q[j] = p[j];
               
               p = q;
            
               Polygon poly = null;
               if (p.length == 3)
                  poly = new MyTriangle(p);
               else if (p.length == 4)
               {
                  try
                  {
                     poly = new MySquare(p);
                  }
                  catch (IllegalArgumentException e)
                  {
                     poly = new MyRectangle(p);
                  }
               }
               else
                  System.out.println(">>> Errore di formato alla riga" + numRiga);
            
               if (poly != null)
               {
                  // System.out.println("area = " + poly.area());
                  // System.out.println("perimetro = " + poly.perimetro());
                  archivio.add(poly);
               }
            }
            catch (NoSuchElementException e)
            {
               System.out.println(">>> Errore di formato numerico alla riga" + numRiga);
            }
         }
      }

      // stampa poligoni
      System.out.println();
      System.out.println("Archivio ordinato");
      while (!archivio.isEmpty())
         System.out.println(archivio.removeMax());
   }
}






