/**
  * SortableContainerTester
  * Classe di prova.
  * @author Adriano Luchetta
  * @version 7-Nov-2003
  * @version 20-Nov-2004
  * @version 16-Nov-2006
  */

import java.util.Scanner;
import java.util.NoSuchElementException;

public class SortableContainerTester
{
   public static void main(String[] args)
   {
      final char COMMENT_CHARACTER = '*';

      SortableContainer list1 = new SortableContainer();
      SortableContainer list2 = new SortableContainer();
      Scanner in = new Scanner(System.in);

      // acquisizione dati
      int lineCounter = 0;
      String line = "";
      while (in.hasNextLine())
      {
         lineCounter++;
         line = in.nextLine();
         if (line.charAt(0) != COMMENT_CHARACTER)
         {
            Scanner tok = new Scanner(line);
            tok.useDelimiter("[:]+");

            try
            {
               String nome = tok.next();
               int matricola = tok.nextInt();
               list1.add(new Studente(nome, matricola));
               list2.add(new Studente(nome, matricola));
            }
            catch (NoSuchElementException e)
            {
               System.out.println(">>> riga " + lineCounter + " errata: " + line);
            }
         
            tok.close();
         }
      }

      in.close();

      // stampa elenco non ordinato
      System.out.println("\n*** ELENCO NON ORDINATO DI STUDENTI ***");
      while (!list1.isEmpty())
         System.out.println((Studente)list1.removeLast());
         
      // ordinamento e stampa
      list2.sort();
      System.out.println("\n*** ELENCO ORDINATO DI STUDENTI ***");
      while (!list2.isEmpty())
         System.out.println((Studente)list2.removeLast());
   }
}




